/* Peter Schaeffer */
#include <stdio.h>

FILE *in;

int m, n, c, r;
char p[100][100];

int main()
{
  in=stdin;
  while(1)
    {
      fscanf(in, " %d %d %d %d ", &n, &m, &r, &c);
      if (!r) break;
      for(int i=0; i<n; i++)
	{
	  for(int j=0; j<m; j++)
	    {
	      fscanf(in, " %c ", &p[i][j]);
	      p[i][j]-='0';
	    }
	}
      int count=0;
      for(int i=0; i<=n-r; i++)
	for(int j=0; j<=m-c; j++)
	  if (p[i][j])
	    {
	      for(int k=0; k<r; k++)
		for(int l=0; l<c; l++)
		  p[i+k][j+l]^=1;
	      count++;
	    }
      for(int i=0; i<n; i++)
	for(int j=0; j<m; j++)
	  if (p[i][j]) count=-1;
      printf("%d\n", count);
    }
  return 0;
}
